<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.math.varint.ops;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.IOException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.InputStream;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.OutputStream;<a name="line.40"></a>
<FONT color="green">041</FONT>    <a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.io.DataInputInputStream;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.io.DataOutputOutputStream;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.math.NumberOperations;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.math.ops.AbstractNumberOps;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.math.varint.VarIntFactory;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.math.varint.VarIntNumber;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.math.varint.VarIntUtil;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.math.varint.array.VarIntOperators;<a name="line.49"></a>
<FONT color="green">050</FONT>    <a name="line.50"></a>
<FONT color="green">051</FONT>    /**<a name="line.51"></a>
<FONT color="green">052</FONT>     * {@link NumberOperations Number operations} for {@link VarIntNumber}s.<a name="line.52"></a>
<FONT color="green">053</FONT>     * A singleton {@link #instance() instance} exists for this class. <a name="line.53"></a>
<FONT color="green">054</FONT>     */<a name="line.54"></a>
<FONT color="green">055</FONT>    public class VarIntOperations extends AbstractNumberOps&lt;VarIntNumber&gt; {<a name="line.55"></a>
<FONT color="green">056</FONT>            private static VarIntOperations sInstance;<a name="line.56"></a>
<FONT color="green">057</FONT>            <a name="line.57"></a>
<FONT color="green">058</FONT>            /**<a name="line.58"></a>
<FONT color="green">059</FONT>             * Returns the singleton instance<a name="line.59"></a>
<FONT color="green">060</FONT>             * @return the singleton instance<a name="line.60"></a>
<FONT color="green">061</FONT>             */<a name="line.61"></a>
<FONT color="green">062</FONT>            public static VarIntOperations instance() {<a name="line.62"></a>
<FONT color="green">063</FONT>                    if (sInstance == null) {<a name="line.63"></a>
<FONT color="green">064</FONT>                            sInstance = new VarIntOperations();<a name="line.64"></a>
<FONT color="green">065</FONT>                    }<a name="line.65"></a>
<FONT color="green">066</FONT>                    return sInstance;<a name="line.66"></a>
<FONT color="green">067</FONT>            }<a name="line.67"></a>
<FONT color="green">068</FONT>            public Class&lt;VarIntNumber&gt; numberClass() {<a name="line.68"></a>
<FONT color="green">069</FONT>                    return VarIntNumber.class;<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>            public VarIntNumber[] newArray(int size) {<a name="line.71"></a>
<FONT color="green">072</FONT>                    return new VarIntNumber[size];<a name="line.72"></a>
<FONT color="green">073</FONT>            }<a name="line.73"></a>
<FONT color="green">074</FONT>            public VarIntNumber[][] newArray(int rows, int cols) {<a name="line.74"></a>
<FONT color="green">075</FONT>                    return new VarIntNumber[rows][cols];<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>            public VarIntNumber valueOf(String s) {<a name="line.77"></a>
<FONT color="green">078</FONT>                    return VarIntFactory.create(s);<a name="line.78"></a>
<FONT color="green">079</FONT>            }<a name="line.79"></a>
<FONT color="green">080</FONT>            public VarIntNumber valueOf(Number number) {<a name="line.80"></a>
<FONT color="green">081</FONT>                    return VarIntOperators.INTEGER_DIVISION_INSTANCE.converter().operate(number);<a name="line.81"></a>
<FONT color="green">082</FONT>            }<a name="line.82"></a>
<FONT color="green">083</FONT>            public VarIntNumber valueOf(long value) {<a name="line.83"></a>
<FONT color="green">084</FONT>                    return VarIntFactory.create(value);<a name="line.84"></a>
<FONT color="green">085</FONT>            }<a name="line.85"></a>
<FONT color="green">086</FONT>            public VarIntNumber valueOf(double value) {<a name="line.86"></a>
<FONT color="green">087</FONT>                    return valueOf(String.valueOf(value));<a name="line.87"></a>
<FONT color="green">088</FONT>            }<a name="line.88"></a>
<FONT color="green">089</FONT>            @Override<a name="line.89"></a>
<FONT color="green">090</FONT>            public VarIntNumber abs(VarIntNumber number) {<a name="line.90"></a>
<FONT color="green">091</FONT>                    return number.abs();<a name="line.91"></a>
<FONT color="green">092</FONT>            }<a name="line.92"></a>
<FONT color="green">093</FONT>            public VarIntNumber add(VarIntNumber numA, VarIntNumber numB) {<a name="line.93"></a>
<FONT color="green">094</FONT>                    return numA.add(numB);<a name="line.94"></a>
<FONT color="green">095</FONT>            }<a name="line.95"></a>
<FONT color="green">096</FONT>            public VarIntNumber divide(VarIntNumber numA, VarIntNumber numB) {<a name="line.96"></a>
<FONT color="green">097</FONT>                    return numA.divide(numB);<a name="line.97"></a>
<FONT color="green">098</FONT>            }<a name="line.98"></a>
<FONT color="green">099</FONT>            @Override<a name="line.99"></a>
<FONT color="green">100</FONT>            public VarIntNumber invert(VarIntNumber number) {<a name="line.100"></a>
<FONT color="green">101</FONT>                    return VarIntNumber.ONE.divide(number);<a name="line.101"></a>
<FONT color="green">102</FONT>            }<a name="line.102"></a>
<FONT color="green">103</FONT>            @Override<a name="line.103"></a>
<FONT color="green">104</FONT>            public boolean isOne(VarIntNumber number) {<a name="line.104"></a>
<FONT color="green">105</FONT>                    return VarIntNumber.ONE.equals(number);<a name="line.105"></a>
<FONT color="green">106</FONT>            }<a name="line.106"></a>
<FONT color="green">107</FONT>            @Override<a name="line.107"></a>
<FONT color="green">108</FONT>            public boolean isZero(VarIntNumber number) {<a name="line.108"></a>
<FONT color="green">109</FONT>                    return number.signum() == 0;<a name="line.109"></a>
<FONT color="green">110</FONT>            }<a name="line.110"></a>
<FONT color="green">111</FONT>            public VarIntNumber multiply(VarIntNumber numA, VarIntNumber numB) {<a name="line.111"></a>
<FONT color="green">112</FONT>                    return numA.multiply(numB);<a name="line.112"></a>
<FONT color="green">113</FONT>            }<a name="line.113"></a>
<FONT color="green">114</FONT>            public VarIntNumber negate(VarIntNumber number) {<a name="line.114"></a>
<FONT color="green">115</FONT>                    return number.negate();<a name="line.115"></a>
<FONT color="green">116</FONT>            }<a name="line.116"></a>
<FONT color="green">117</FONT>            public VarIntNumber one() {<a name="line.117"></a>
<FONT color="green">118</FONT>                    return VarIntNumber.ONE;<a name="line.118"></a>
<FONT color="green">119</FONT>            }<a name="line.119"></a>
<FONT color="green">120</FONT>            public VarIntNumber subtract(VarIntNumber numA, VarIntNumber numB) {<a name="line.120"></a>
<FONT color="green">121</FONT>                    return numA.subtract(numB);<a name="line.121"></a>
<FONT color="green">122</FONT>            }<a name="line.122"></a>
<FONT color="green">123</FONT>            public VarIntNumber zero() {<a name="line.123"></a>
<FONT color="green">124</FONT>                    return VarIntNumber.ZERO;<a name="line.124"></a>
<FONT color="green">125</FONT>            }<a name="line.125"></a>
<FONT color="green">126</FONT>            public int compare(VarIntNumber o1, VarIntNumber o2) {<a name="line.126"></a>
<FONT color="green">127</FONT>                    return o1.compareTo(o2);<a name="line.127"></a>
<FONT color="green">128</FONT>            }<a name="line.128"></a>
<FONT color="green">129</FONT>            public VarIntNumber reduce(VarIntNumber number) {<a name="line.129"></a>
<FONT color="green">130</FONT>                    return number;<a name="line.130"></a>
<FONT color="green">131</FONT>            }<a name="line.131"></a>
<FONT color="green">132</FONT>            public VarIntNumber[] reduceVector(boolean cloneOnChange, VarIntNumber... vector) {<a name="line.132"></a>
<FONT color="green">133</FONT>                    if (vector.length &gt; 0) {<a name="line.133"></a>
<FONT color="green">134</FONT>                            VarIntNumber gcd = VarIntUtil.gcd(vector).abs();<a name="line.134"></a>
<FONT color="green">135</FONT>                            if (!isOne(gcd) &amp;&amp; gcd.signum() != 0) {<a name="line.135"></a>
<FONT color="green">136</FONT>                                    if (cloneOnChange) vector = vector.clone();<a name="line.136"></a>
<FONT color="green">137</FONT>                                    for (int i = 0; i &lt; vector.length; i++) {<a name="line.137"></a>
<FONT color="green">138</FONT>                                            vector[i] = vector[i].divide(gcd);<a name="line.138"></a>
<FONT color="green">139</FONT>                                    }<a name="line.139"></a>
<FONT color="green">140</FONT>                            }<a name="line.140"></a>
<FONT color="green">141</FONT>                    }<a name="line.141"></a>
<FONT color="green">142</FONT>                    return vector;<a name="line.142"></a>
<FONT color="green">143</FONT>            }<a name="line.143"></a>
<FONT color="green">144</FONT>            public int signum(VarIntNumber number) {<a name="line.144"></a>
<FONT color="green">145</FONT>                    return number.signum();<a name="line.145"></a>
<FONT color="green">146</FONT>            }<a name="line.146"></a>
<FONT color="green">147</FONT>            public VarIntNumber pow(VarIntNumber numA, VarIntNumber numB) {<a name="line.147"></a>
<FONT color="green">148</FONT>                    final int expSign = numB.signum();<a name="line.148"></a>
<FONT color="green">149</FONT>                    if (expSign == 0) return VarIntNumber.ONE;<a name="line.149"></a>
<FONT color="green">150</FONT>                    if (VarIntNumber.ONE.equals(numA)) return VarIntNumber.ONE;<a name="line.150"></a>
<FONT color="green">151</FONT>                    if (expSign &lt; 0) {<a name="line.151"></a>
<FONT color="green">152</FONT>                            //perform 'integer division'<a name="line.152"></a>
<FONT color="green">153</FONT>                            return VarIntNumber.ZERO;<a name="line.153"></a>
<FONT color="green">154</FONT>                    }<a name="line.154"></a>
<FONT color="green">155</FONT>                    if (numB.compareTo(VarIntFactory.create(Integer.MAX_VALUE)) &gt; 0) {<a name="line.155"></a>
<FONT color="green">156</FONT>                            throw new ArithmeticException(<a name="line.156"></a>
<FONT color="green">157</FONT>                                    "exponent too large, only integer range supported: " + <a name="line.157"></a>
<FONT color="green">158</FONT>                                    numB + " &gt; " + Integer.MAX_VALUE<a name="line.158"></a>
<FONT color="green">159</FONT>                            );                                      <a name="line.159"></a>
<FONT color="green">160</FONT>                    }<a name="line.160"></a>
<FONT color="green">161</FONT>                    return numA.pow(numB.intValue());<a name="line.161"></a>
<FONT color="green">162</FONT>            }<a name="line.162"></a>
<FONT color="green">163</FONT>            public byte[] toByteArray(VarIntNumber number) {<a name="line.163"></a>
<FONT color="green">164</FONT>                    return number.toByteArray();<a name="line.164"></a>
<FONT color="green">165</FONT>            }<a name="line.165"></a>
<FONT color="green">166</FONT>            public void writeTo(VarIntNumber number, DataOutput out) throws IOException {<a name="line.166"></a>
<FONT color="green">167</FONT>                    number.writeTo(out instanceof OutputStream ? (OutputStream)out : new DataOutputOutputStream(out));<a name="line.167"></a>
<FONT color="green">168</FONT>            }<a name="line.168"></a>
<FONT color="green">169</FONT>            @SuppressWarnings("cast")<a name="line.169"></a>
<FONT color="green">170</FONT>        public VarIntNumber fromByteArray(byte[] bytes) {<a name="line.170"></a>
<FONT color="green">171</FONT>                    return VarIntFactory.create(bytes);<a name="line.171"></a>
<FONT color="green">172</FONT>            }<a name="line.172"></a>
<FONT color="green">173</FONT>            public VarIntNumber readFrom(DataInput in) throws IOException {<a name="line.173"></a>
<FONT color="green">174</FONT>                    return VarIntFactory.readFrom(in instanceof InputStream ? (InputStream)in : new DataInputInputStream(in));<a name="line.174"></a>
<FONT color="green">175</FONT>            }<a name="line.175"></a>
<FONT color="green">176</FONT>            public int byteLength() {<a name="line.176"></a>
<FONT color="green">177</FONT>                    return -1;<a name="line.177"></a>
<FONT color="green">178</FONT>            }<a name="line.178"></a>
<FONT color="green">179</FONT>    }<a name="line.179"></a>




























































</PRE>
</BODY>
</HTML>
